#ifndef __OpenViBE_AcquisitionServer_CDriverModularEeg_H__
#define __OpenViBE_AcquisitionServer_CDriverModularEeg_H__

#include "../ovasIDriver.h"
#include "../ovasCHeader.h"


#if defined OVAS_OS_Windows
 typedef void * FD_TYPE;
#else
 typedef OpenViBE::int32 FD_TYPE;
#endif


namespace OpenViBEAcquisitionServer
{
	class CDriverModularEeg : public OpenViBEAcquisitionServer::IDriver
	{
	public:

		CDriverModularEeg(void);
		virtual void release(void);
		virtual const char* getName(void);

		virtual OpenViBE::boolean initialize(
			const OpenViBE::uint32 ui32SampleCountPerSentBlock,
			OpenViBEAcquisitionServer::IDriverCallback& rCallback);
		virtual OpenViBE::boolean uninitialize(void);

		virtual OpenViBE::boolean start(void);
		virtual OpenViBE::boolean stop(void);
		virtual OpenViBE::boolean loop(void);

		virtual OpenViBE::boolean isConfigurable(void);
		virtual OpenViBE::boolean configure(void);
		virtual const OpenViBEAcquisitionServer::IHeader* getHeader(void) { return &m_oHeader; }

		void logPacket(void);
		OpenViBE::uint32 parseByteP2(OpenViBE::uint8 ui8Actbyte);

		OpenViBE::uint32 initTty(FD_TYPE * pFileDescriptor, OpenViBE::uint32 ui32TtyNumber );
		OpenViBE::int32  readPacketFromTty(FD_TYPE i32FileDescriptor);
		void closeTty(FD_TYPE i32FileDescriptor);

	protected:

		OpenViBEAcquisitionServer::IDriverCallback* m_pCallback;
		OpenViBEAcquisitionServer::CHeader m_oHeader;

		OpenViBE::boolean m_bInitialized;
		OpenViBE::boolean m_bStarted;
		OpenViBE::uint32 m_ui32SampleCountPerSentBlock;
		OpenViBE::float32* m_pSample;

		OpenViBE::uint32 m_ui32TotalSampleCount;
		OpenViBE::uint32 m_ui32StartTime;

		FD_TYPE  m_i32FileDescriptor;
		OpenViBE::uint16 m_ui16Readstate;
		OpenViBE::uint16 m_ui16ExtractPosition;
 		OpenViBE::uint8  m_ui8PacketNumber;
		OpenViBE::uint8  m_ui8LastPacketNumber;
 		OpenViBE::int32  m_i32ChannelBuffer[6];
		OpenViBE::uint16 m_ui16Switches;

	};
};

#endif // __OpenViBE_AcquisitionServer_CDriverModularEeg_H__
